import requests, json, base64
from requests.auth import HTTPBasicAuth
from datetime import datetime
from __init__ import db
import ssl, base64



class FlaskMPesa(object):
    
    def __init__(self, MpesaAccessToken,phone ,cost):
        self.MpesaAccessToken = MpesaAccessToken
        self.phone = phone
        self.cost = cost
        # self.host = "https://noredge.carnasi.com"
        self.host = "https://smart-jars-exist.loca.lt"
        self.MPESA_ENVIRONMENT = "sandbox"
        self.MPESA_CONSUMER_KEY = "0hO34ld3fEQolAV1L6OeMz0OR3JGyy3a"
        self.MPESA_CONSUMER_SECRET = "mjT2Dp9DbGnTM27x"
        self.MPESA_EXPRESS_SHORTCODE = "174379"
        self.MPESA_C2B_SHORTCODE = "600344"
        self.LNM_PHONE_NUMBER = phone
        self.MPESA_PASSKEY = "bfb279f9aa9bdbcf158e97dd71a467cd2e0c893059b10f78e6b72ada1ed2c919"
        self.MPESA_SHORTCODE = "174379"
        self.lipa_time = datetime.now().strftime('%Y%m%d%H%M%S')
        self.callbackURL = f"{self.host}/mpesa"
        self.ConfirmationURL = f"{self.host}/mpesa_confirmation"
        self.ValidationURL = f"{self.host}/mpesa_validation"

    def MpesaLink(self, evironment):
        if evironment == 'development':
            return 'https://darajasimulator.azurewebsites.net/'
        elif evironment == 'sandbox':
            return 'https://sandbox.safaricom.co.ke/'
        elif evironment == 'production':
            return 'https://api.safaricom.co.ke/'

# import requests
# ​
# response = requests.request("GET", 'https://sandbox.safaricom.co.ke/oauth/v1/generate?grant_type=client_credentials', headers = { 'Authorization': 'Bearer cFJZcjZ6anEwaThMMXp6d1FETUxwWkIzeVBDa2hNc2M6UmYyMkJmWm9nMHFRR2xWOQ==' })
# print(response.text.encode('utf8'))
    def getMPesaToken(self):
        url = f'{self.MpesaLink(self.MPESA_ENVIRONMENT)}/oauth/v1/generate?grant_type=client_credentials'

        message = f"{self.MPESA_CONSUMER_KEY}:{self.MPESA_CONSUMER_SECRET}"
        message_bytes = message.encode('ascii')
        base64_bytes = base64.b64encode(message_bytes)
        base64_message = base64_bytes.decode('ascii')
        
        headers = {'Accept': 'application/json',
                   'Authorization': f'Bearer {base64_message}'}
        
        response = requests.get(url, headers=headers, auth = HTTPBasicAuth(self.MPESA_CONSUMER_KEY, self.MPESA_CONSUMER_SECRET))
        # response = requests.get(url, headers=headers)
        
        r_json = json.loads(response.text)
        
        mpesa_access_token = r_json.get('access_token')
        
        expiry = r_json.get('expires_in')
        
        access_token = self.MpesaAccessToken(token = mpesa_access_token, expiry = int(expiry))
        
        db.session.add(access_token)
        db.session.commit()

        return mpesa_access_token

    def mpesa_access_token(self):
        
        mpesa_access_token = self.MpesaAccessToken.query.order_by(self.MpesaAccessToken.date.asc()).first()
        
        if mpesa_access_token == None:
            mpesa_access_token = self.getMPesaToken()
        else:
            delta = datetime.now() - mpesa_access_token.date
            timelaps = (delta.seconds)
            if timelaps < mpesa_access_token.expiry:
                mpesa_access_token = mpesa_access_token.token
                
            else:
                db.session.delete(mpesa_access_token)
                db.session.commit()
                mpesa_access_token = self.getMPesaToken()
                
        return mpesa_access_token

    def lipa_na_mpesa_online(self):
        
        
        data_to_encode = self.MPESA_SHORTCODE + self.MPESA_PASSKEY + self.lipa_time
        
        online_password = base64.b64encode(data_to_encode.encode('ascii'))
        decode_password = online_password.decode('ascii')
        
        access_token = self.mpesa_access_token()
        api_url = f"{self.MpesaLink(self.MPESA_ENVIRONMENT)}/mpesa/stkpush/v1/processrequest"
        headers = {"Authorization": "Bearer %s" % access_token}
        request = {
            "BusinessShortCode": self.MPESA_SHORTCODE,
            "Password": decode_password,
            "Timestamp": self.lipa_time,
            "TransactionType": "CustomerPayBillOnline",#"CustomerBuyGoodsOnline", # "CustomerPayBillOnline",
            "Amount": self.cost,
            "PartyA": self.phone,  # replace with your phone number to get stk push
            "PartyB": self.MPESA_SHORTCODE,
            "PhoneNumber": self.phone,  # replace with your phone number to get stk push
            "CallBackURL": self.callbackURL,#"https://{}/mpesa".format(host), #
            "AccountReference": "Athanas Mbele Foundation",
            "TransactionDesc": "Donation Contribution"
        }
        response = requests.post(api_url, json=request, headers=headers)
        return json.loads(response.text)

    def register_urls(self):
        access_token = self.mpesa_access_token()
        api_url = f"{self.MpesaLink(self.MPESA_ENVIRONMENT)}/mpesa/c2b/v1/registerurl"
        headers = {"Authorization": "Bearer %s" % access_token}
        options = {"ShortCode": self.MPESA_C2B_SHORTCODE,
                "ResponseType": "Completed",
                "ConfirmationURL": self.ConfirmationURL,
                "ValidationURL": self.ValidationURL}
        response = requests.post(api_url, json=options, headers=headers)

        return json.loads(response.text)